﻿Imports System.Collections.Generic

Public Class TalkForm
    Private m_IntermissionWatcher As ClockWatcher

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Debug.WriteLine("Starting")

        ' Create the ClockWatcher.
        m_IntermissionWatcher = New ClockWatcher
    End Sub

    Private Sub m_IntermissionWatcher_BreakTime(ByVal the_time As Date)
        MessageBox.Show("It is now " & the_time.ToString())
    End Sub

    ' Assign the event handler.
    Private Sub btnAddHandler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddHandler.Click
        AddHandler m_IntermissionWatcher.BreakTime, AddressOf m_IntermissionWatcher_BreakTime
    End Sub

    ' Remove the event handler.
    Private Sub btnRemoveHandler_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemoveHandler.Click
        RemoveHandler m_IntermissionWatcher.BreakTime, AddressOf m_IntermissionWatcher_BreakTime
    End Sub

    Private Sub btnRaiseEvent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRaiseEvent.Click
        m_IntermissionWatcher.Fire()
    End Sub

    Private Sub btnMakeEmployee_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMakeEmployee.Click
        Dim emp As New Employee
        emp = Nothing
    End Sub

    Private Sub btnMakeManager_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMakeManager.Click
        Dim mgr As New Manager
        AddHandler m_IntermissionWatcher.BreakTime, AddressOf mgr.ClockWatcher_BreakTime
        mgr = Nothing
    End Sub
End Class

Public Class ClockWatcher
    ' Normal event.
    Public Event OldTick(ByVal the_time As DateTime)

    ' Custom event.
    ' The event delegate type.
    Public Delegate Sub TickDelegate(ByVal the_time As DateTime)

    ' A data structure to store the delegates.
    Private m_Delegates As New Collection(Of TickDelegate)

    ' The custom event accessors.
    Public Custom Event BreakTime As TickDelegate
        AddHandler(ByVal value As TickDelegate)
            Debug.WriteLine("AddHandler " & TypeName(value.Target))
            m_Delegates.Add(value)
        End AddHandler

        RemoveHandler(ByVal value As TickDelegate)
            Debug.WriteLine("RemoveHandler " & TypeName(value.Target))
            m_Delegates.Remove(value)
        End RemoveHandler

        RaiseEvent(ByVal the_time As Date)
            Debug.WriteLine("RaiseEvent")
            For Each tick_delegate As TickDelegate In m_Delegates
                tick_delegate.Invoke(Now)
            Next tick_delegate
        End RaiseEvent
    End Event

    Public Sub Fire()
        RaiseEvent BreakTime(Now)
    End Sub
End Class

Public Class Employee
    Private WithEvents m_ClockWatcher As New ClockWatcher
    Private Sub m_ClockWatcher_BreakTime(ByVal the_time As Date) Handles m_ClockWatcher.BreakTime
        MessageBox.Show("Employee: BreakTime")
    End Sub
End Class

Public Class Manager
    Public Sub ClockWatcher_BreakTime(ByVal the_time As Date)
        MessageBox.Show("Manager: BreakTime")
    End Sub
End Class
