﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Unsigned types.
        Dim uint As UInteger = 1
        Dim int As Integer = 2
        Debug.WriteLine( _
            TypeName(uint) & " * " & _
            TypeName(int) & " = " & _
            TypeName(uint * int))

        Dim arr1(0 To 5) As Integer
        Dim arr2(0 To 5) As Integer

        Debug.WriteLine("arr1(0 To 5): " & _
            arr1.GetLowerBound(0) & " - " & arr1.GetUpperBound(0))
        Debug.WriteLine("arr2(5): " & _
            arr2.GetLowerBound(0) & " - " & arr2.GetUpperBound(0))

        Dim lengths() As Integer = {5}
        Dim lower_bounds() As Integer = {1}
        Dim arr3 As Array = Array.CreateInstance( _
            GetType(Integer), lengths, lower_bounds)
        Debug.WriteLine("arr3: " & _
            arr3.GetLowerBound(0) & " - " & arr3.GetUpperBound(0))

        ' Bit shift operators.
        Debug.WriteLine(ToBinary(1))
        Debug.WriteLine(ToBinary(8))
        Debug.WriteLine(ToBinary(16))
        Debug.WriteLine(ToBinary(123))
        Debug.WriteLine(ToBinary(-1))
        Debug.WriteLine(ToBinary(-2))
        Dim int1 As Integer = 1
        Debug.WriteLine(ToBinary(int1))
        int1 = int1 << 30
        Debug.WriteLine(ToBinary(int1))
        int1 <<= 30
        Debug.WriteLine(ToBinary(int1))
        int1 <<= 30
        Debug.WriteLine(ToBinary(int1))

        Dim i As UShort = 1
        i <<= 2

        Dim b As Byte = 1
        Debug.WriteLine(ToBinary(b, 8))
        b <<= 3
        Debug.WriteLine(ToBinary(b, 8))

        ' Using Using blocks.
        Using red_pen As New Pen(Color.Red)
            '...
        End Using

        Dim green_pen As New Pen(Color.Green)
        Using green_pen
            '...
        End Using

        Dim blue_pen As New Pen(Color.Blue)
        Try
            '...
        Finally
            blue_pen.Dispose()
        End Try

        ' Continue.
        For i = 1 To 6
            If i Mod 2 = 0 Then Continue For
            Debug.WriteLine(i)
        Next i

        ' IsNot.
        Dim obj1 As New Object
        Dim obj2 As New Object
        If obj1 IsNot Nothing Then Debug.WriteLine("Not Nothing")
        If obj1 IsNot obj2 Then Debug.WriteLine("Not The Same")
        obj1 = obj2
        If Not (obj1 IsNot obj2) Then Debug.WriteLine("The Same")

        ' TryCast.
        Dim p As New ParentClass
        Dim c As New ChildClass
        Dim o As Object

        c = TryCast(p, ChildClass)
        Debug.WriteLine("c is Nothing: " & (c Is Nothing))
        o = TryCast(p, Object)
        Debug.WriteLine("o is Nothing: " & (o Is Nothing))

        o = New Integer
        p = TryCast(o, ParentClass)
        Debug.WriteLine("p is Nothing: " & (p Is Nothing))

        ' Operator overloading.
        Dim complex1 As New ComplexNumber(1, 2)
        Dim complex2 As New ComplexNumber(3, 4)
        Dim complex3 As ComplexNumber
        complex3 = complex1 + complex2
        Debug.WriteLine(complex1.ToString() & " + " & complex2.ToString() & " = " & complex3.ToString())
        complex3 = complex1 - complex2
        Debug.WriteLine(complex1.ToString() & " - " & complex2.ToString() & " = " & complex3.ToString())
        complex3 = complex1 * complex2
        Debug.WriteLine(complex1.ToString() & " * " & complex2.ToString() & " = " & complex3.ToString())

        complex1 *= complex2
        'complex1 = complex2 Mod complex3

        'Dim result As Integer = complex1 And complex2
        complex2 = -complex1



        Me.Close()
    End Sub

    Private Class ParentClass
    End Class
    Private Class ChildClass
        Inherits ParentClass
    End Class

    Private Function ToBinary(ByVal i As Integer, Optional ByVal digits As Integer = 32) As String
        Dim result As String = ""
        Dim mask As UInteger = 1
        For power As Integer = 0 To digits - 1
            If (mask And i) = 0 Then
                result = "0" & result
            Else
                result = "1" & result
            End If
            mask <<= 1
        Next power
        Return result
    End Function

    Private Class ComplexNumber
        Public Re As Single
        Public Im As Single

        Public Sub New()
        End Sub
        Public Sub New(ByVal real_part As Single, ByVal imaginary_part As Single)
            Re = real_part
            Im = imaginary_part
        End Sub
        Public Overrides Function ToString() As String
            Return "(" & Re.ToString() & " + " & Im.ToString() & "i" & ")"
        End Function
        Public Function Magnitude() As Single
            Return CSng(Math.Sqrt(Re * Re + Im * Im))
        End Function

        Public Shared Operator +(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return New ComplexNumber( _
                number1.Re + number2.Re, _
                number1.Im + number2.Im)
        End Operator
        Public Shared Operator -(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return New ComplexNumber( _
                number1.Re - number2.Re, _
                number1.Im - number2.Im)
        End Operator
        Public Shared Operator -(ByVal number1 As ComplexNumber) As ComplexNumber
            Return New ComplexNumber(-number1.Re, -number1.Im)
        End Operator
        Public Shared Operator *(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return New ComplexNumber( _
                number1.Re * number2.Re - number1.Im * number2.Im, _
                number1.Re * number2.Im + number1.Im * number2.Re)
        End Operator
        Public Shared Operator /(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator \(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator ^(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator &(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator Like(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator Mod(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator And(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return New ComplexNumber
        End Operator
        Public Shared Operator Or(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator Xor(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator Not(ByVal number1 As ComplexNumber) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator >>(ByVal number1 As ComplexNumber, ByVal digits As Integer) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator <<(ByVal number1 As ComplexNumber, ByVal digits As Integer) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator >=(ByVal number1 As ComplexNumber, ByVal digits As Integer) As ComplexNumber
            Return Nothing
        End Operator
        Public Shared Operator <=(ByVal number1 As ComplexNumber, ByVal digits As Integer) As ComplexNumber
            Return Nothing
        End Operator

        Public Shared Operator >(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As Boolean
            Return number1.Magnitude > number2.Magnitude
        End Operator
        Public Shared Operator <(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As Boolean
            Return Not number1 > number2
        End Operator
        Public Shared Operator =(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As Boolean
            Return (number1.Re = number2.Re) AndAlso _
                (number1.Im = number2.Im)
        End Operator
        Public Shared Operator <>(ByVal number1 As ComplexNumber, ByVal number2 As ComplexNumber) As Boolean
            Return Not number1 = number2
        End Operator
        Public Shared Operator =(ByVal number1 As ComplexNumber, ByVal number2 As Integer) As Integer
            Return 12
        End Operator
        Public Shared Operator <>(ByVal number1 As ComplexNumber, ByVal number2 As Integer) As Integer
            Return -12
        End Operator
        Public Shared Operator IsTrue(ByVal number1 As ComplexNumber) As Boolean
            Return False
        End Operator
        Public Shared Operator IsFalse(ByVal number1 As ComplexNumber) As Boolean
            Return False
        End Operator

        Public Shared Widening Operator CType(ByVal number1 As ComplexNumber) As Single
            Return number1.Magnitude()
        End Operator
        Public Shared Narrowing Operator CType(ByVal number1 As ComplexNumber) As Integer
            Return CInt(number1.Magnitude())
        End Operator

    End Class
End Class
